<id>
FATAL ERROR TRACKING
</id>

<version>
.001
</version>

<mod info>
Keep a log of fatal errors generated to the end user. and have the ability to clear then. 
I'm only capturing the time of the error, the error message, the user who generated it,
and the board and action from the %info. Suggestions are welcome.

install mod copy errorlog.pl to your sources directory
</mod info>

<author>
-=Gwyden=-
</author>

<homepage>
mailto:gwyden@dreamflyght.com
</homepage>

<edit file>
sources\subs.pl
</edit file>

<search for>
sub fatal_error {
	my $e = $_[0];
	&ToHTML($e);
	# allows the following HTML-tags in error messages: <BR> <B>
	$e =~ s/&lt;(\/?)br&gt;/<$1BR>/ig;
	$e =~ s/&lt;(\/?)b&gt;/<$1B>/ig;
</search for>

<add after>

# ERROR LOGGING
	# error log is in the format $date|$usersname|$error|$board|$action
	$tmperror = $e;
	$tmperror =~ s/\n//ig;
	fopen(FILE, ">>$vardir/error.log");
	print FILE time() . "|" . $date . "|" . $username . "|" . $tmperror . "|" . $currentboard . "|" . $action . "\n";
	fclose(FILE);
	undef($tmperror);
# END ERROR LOGGING


</add after>

<edit file>
sources\admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=ipban">$txt{'206'}</a><br>
</search for>

<add after>
        - <a href="$cgi;action=viewerrorlog">$errorlog{'1'}</a><br>

</add after>

<edit file>
sources\sublist.pl
</edit file>

<search for>
%director=(

</search for>

<add after>
#error LOG
'viewerrorlog',"errorlog.pl&ViewErrors",
'deleteerrors',"errorlog.pl&DeleteErrors",

#END ERROR LOG
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>

$errorlog{'1'} = "Error Log";
$errorlog{'2'} = "View Errors";
$errorlog{'3'} = "Viewing Errors";
$errorlog{'4'} = "total errors";
$errorlog{'5'} = "Date";
$errorlog{'6'} = "User";
$errorlog{'7'} = "Error Message";
$errorlog{'8'} = "Board";
$errorlog{'9'} = "Action";
$errorlog{'10'} = "Del";
$errorlog{'11'} = "Delete error(s)";
$errorlog{'12'} = "Are you sure you want to delete the selected ERROR(S)?";

</add after>