# ======================================================================
#
# Perl Source File -- Created with SAPIEN Technologies PrimalSCRIPT(TM)
#
# NAME: errorlog.pl
#
# AUTHOR: -=Gwyden=- , Dreamflyght
# DATE  : 6/1/2003
#
# PURPOSE: Subs for the errorlog processes (view, delete item, clear log)
#
# ======================================================================
sub ViewErrors {
	&is_admin;
	$yytitle = "$errorlog{'2'}";
	# load log file
	fopen(FILE, "$vardir/error.log");
	@errors = <FILE>;
	fclose(FILE);
	$errorcount = @errors;
	$date2 = $date;
	for($i=0;$i<$errorcount;$i++) {
		my @tmpArray = split(/\|/, $errors[$1]);
		$date1 = $tmpArray[1];
		&calcdifference;
		$date_ref = $result;
		#time()|$datecmp|$date|$username|$error|$board|$action
		$tmplist[$i] = qq~$date_ref|$errors[$i]~;
	}

	$sortmode = $INFO{'sort'};
	$sortorder = $INFO{'order'};
	if($sortmode eq "time") {@sortlist = map {$_->[0]} sort{uc($a->[2]) <=> uc($b->[2])} map { [ $_, (split /\|/)[0..2] ] } (@tmplist);}
	elsif($sortmode eq "users") {@sortlist = map {$_->[0]} sort{($b->[4]) cmp ($a->[4])} map { [ $_, (split /\|/)[0..4] ] } (@tmplist);}
	else {@sortlist = @tmplist;}
	if ($INFO{'order'} eq "reverse") {
		@sortlist = reverse @sortlist;
	} else {
		if ($sortmode eq "time") {$order_time = ";order=reverse";}
		elsif ($sortmode eq "users") {$order_users = ";order=reverse";}
	}
	if ($sortmode ne "") {$sortmode = ";sort=".$INFO{'sort'};}
	if ($sortorder ne "") {$sortorder = ";order=".$INFO{'order'};}
	if($INFO{'start'} eq "all") { $start = 0; $showall = 1; } 
	elsif($INFO{'start'}) { $start = $INFO{'start'}; }
	else { $start = 0; }
	$numbegin = ($start + 1);
	$numend = ($start + $MembersPerPage);
	if($numend > $errorcount) { $numend = $errorcount; }
	$b = $start;

	$indexdisplaynum = 3;	# max number of pages to display
	$startpage = 0;
	$tmpa = 1;
	$tmpx = int( $errorcount / $MembersPerPage);
	if ($start >= (($indexdisplaynum-1) * $MembersPerPage)) {
		$startpage = $start - (($indexdisplaynum-1) * $MembersPerPage);
		$tmpa = int( $startpage / $MembersPerPage) + 1;
	}
	if ( $errorcount >= $start + ($indexdisplaynum * $MembersPerPage)) {$endpage = $start + ($indexdisplaynum * $MembersPerPage); } else { $endpage = $errorcount }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=$action;start=0$sortmode$sortorder">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=$action;start=0$sortmode$sortorder">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage) {
		$pageindex .= $start == $counter && !$showall? qq~<B>$tmpa</B>&nbsp;~ : qq~<a href="$cgi;action=$action;start=$counter$sortmode$sortorder">$tmpa</a>&nbsp;~;
		++$tmpa;
	}
	$tmpx = $errorcount - 1 - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage);
	$lastpn = int(($errorcount - 1) / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $errorcount - $MembersPerPage) {$pageindexadd = qq~...&nbsp;~;}
	if ($endpage != $errorcount) {
		$pageindexadd .= qq~<a href="$cgi;action=$action;start=$lastptn$sortmode$sortorder">$lastpn</a>&nbsp;~;
	}
	$pageindex .= $pageindexadd;
	if ($showall) {
		$pageindex .= qq~$txt{'190'}~; $MembersPerPage = $errorcount; $startmode = qq~;start=all~; $heading = qq~$amv_txt{'16'} $errorcount $amv_txt{'17'}~;
	} else {
		$pageindex .= qq~<a href="$cgi;action=$action;start=all$sortmode$sortorder">$txt{'190'}</a>~;
		$startmode = qq~;start=$start~;
		$heading = qq~$errorlog{'3'} $numbegin $txt{'311'} $numend ($txt{'309'} $errorcount $errorlog{'4'})~;
	}
	$yymain .= qq~\
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<form name="errorlog_form" action="$cgi;action=deleteerrors;$startmode$sortmode$sortorder" method="POST" onSubmit="submitonce(this);">
<input type="hidden" name="button" value="4">
<table border="0" cellspacing="0" cellpadding="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
      <table border="0" cellspacing="1" cellpadding="4" width="100%">
        <tr>
          <td bgcolor="$color{'titlebg'}" align="center" class="titlebg" colspan="9"><font size="2" class="text1" color="$color{'titletext'}"><b>$heading</b></font></td>
        </tr><tr>
          <td class="catbg" bgcolor="$color{'catbg'}" width="20%"><a href="$cgi;action=viewerrorlog$startmode;sort=time$order_time"><b><font size="2">$errorlog{'5'}</font></b></a></td>
          <td class="catbg" bgcolor="$color{'catbg'}" width="7%" align="center"><a href="$cgi;action=viewerrorlog$startmode;sort=users$order_users"><b><font size="2">$errorlog{'6'}</font></b></a></td>
          <td class="catbg" bgcolor="$color{'catbg'}" width="39%" align="center"><b><font size="2">$errorlog{'7'}</font></b></td>
          <td class="catbg" bgcolor="$color{'catbg'}" width="10%" align="center"><b><font size="2">$errorlog{'8'}</font></b></td>
          <td class="catbg" bgcolor="$color{'catbg'}" width="18%" align="center"><b><font size="1">$errorlog{'9'}</font></b></td>
          <td class="catbg" bgcolor="$color{'catbg'}" width="6%" align="center"><b><font size="2">$errorlog{'10'}?</font></b></td>
        </tr>~;
	$numshown = 0; $actualnum = 0;
	while($numshown < $MembersPerPage) {
		$numshown++;
		#$datecmp|$ID|$date|$username|$error|$board|$action
		my ($tmp_datecmp, $tmp_id, $tmp_date, $tmp_username, $tmp_error, $tmp_board, $tmp_action) = split(/\|/, $sortlist[$b]);
		if (!$tmp_id) {next;}
		&FormatUserName($tmp_username);
		$b++;
		$addel = qq~<td class="windowbg" bgcolor="$color{'windowbg'}" width="6%" align="center"><input type="checkbox" name="error$tmp_id" value="$tmp_id"></td>~;
		$actualnum++;
		$yymain .= qq~
        <tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" width="20%"><font size="2">$tmp_date</font></td>
          <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" width="7%"><font size="2"><a href="$cgi;action=$action;username=$useraccount{$tmp_username}">$tmp_username</a></font></td>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center" width="39%"><font size="1">$tmp_error</font></td>
          <td class="windowbg" bgcolor="$color{'windowbg2'}" align="center" width="10%"><font size="1">$tmp_board</font></td>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center" width="18%"><font size="2">$tmp_action</font></td>
          $addel
        </tr>
        ~;
	}
		$yymain .= qq~
		<input type="submit" value="$errorlog{'11'}" onclick="return confirm('$errorlog{'12'}')">
      </table>
    </td>
  </tr>
</table>
</form>
~;
	&template;
	exit;
}


sub ClearErrors {
	&is_admin;
	unlink("$vardir/error.log");
	$yySetLocation = qq~$cgi;action=viewerrorlog~;
	&redirectexit;
}


sub DeleteErrors {
	&is_admin;
	my($count, $memnum, $currentmem, @deademails, $start, $sortmode, $sortorder);
	chomp $FORM{"button"};
	if ($FORM{"button"} ne "4" ) {&fatal_error($txt{'1'});}
	fopen(FILE, "$vardir/error.log");
	@errors = <FILE>;
	fclose(FILE);
	unlink("$vardir/error.log");
	fopen(FILE, ">>$vardir/error.log");
	foreach my $line (@errors){
		chomp $line;
		my ($tmp_id, $tmp_date, $tmp_username, $tmp_error, $tmp_board, $tmp_action) = split(/\|/, $line);
		unless (exists $FORM{"error$tmp_id"}) {
			print FILE $line . "\n";
			#$yymain .= qq~ $line\n~;
		}
	}
	fclose(FILE);
	#&template;
	#exit;
#	unlink("$memberdir/newreg.txt");
	$yySetLocation = qq~$cgi;action=viewerrorlog~;
	&redirectexit;
}
1;